Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ src/Makefile.am	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -18,4 +18,5 @@
 	temporal/cdesign.h \
 	spectral/filterbank.h \
+	spectral/filterbank_mel.h \
 	spectral/mfcc.h \
 	spectral/phasevoc.h \
@@ -49,4 +50,5 @@
 	temporal/cdesign.c \
 	spectral/filterbank.c \
+	spectral/filterbank_mel.c \
 	spectral/mfcc.c \
 	spectral/phasevoc.c \
Index: src/aubio.h
===================================================================
--- src/aubio.h	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ src/aubio.h	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -73,4 +73,5 @@
 #include "temporal/cdesign.h"
 #include "spectral/filterbank.h"
+#include "spectral/filterbank_mel.h"
 #include "spectral/mfcc.h"
 #include "spectral/fft.h"
Index: src/spectral/filterbank.c
===================================================================
--- src/spectral/filterbank.c	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ src/spectral/filterbank.c	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -1,22 +1,22 @@
 /*
-   Copyright (C) 2007 Amaury Hazan <ahazan@iua.upf.edu>
-                  and Paul Brossier <piem@piem.org>
+  Copyright (C) 2007-2009 Paul Brossier <piem@aubio.org>
+                      and Amaury Hazan <ahazan@iua.upf.edu>
 
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
+  This file is part of Aubio.
 
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
+  Aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
 
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+  Aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Aubio.  If not, see <http://www.gnu.org/licenses/>.
 
 */
-
 
 #include "aubio_priv.h"
@@ -32,181 +32,51 @@
     uint_t win_s;
     uint_t n_filters;
-    fvec_t **filters;
+    fvec_t *filters;
 };
 
 aubio_filterbank_t * new_aubio_filterbank(uint_t n_filters, uint_t win_s){
-  /** allocating space for filterbank object */
+  /* allocate space for filterbank object */
   aubio_filterbank_t * fb = AUBIO_NEW(aubio_filterbank_t);
-  uint_t filter_cnt;
   fb->win_s=win_s;
   fb->n_filters=n_filters;
 
-  /** allocating filter tables */
-  fb->filters=AUBIO_ARRAY(fvec_t*,n_filters);
-  for (filter_cnt=0; filter_cnt<n_filters; filter_cnt++)
-    /* considering one-channel filters */
-    fb->filters[filter_cnt]=new_fvec(win_s, 1);
+  /* allocate filter tables, an fvec of length win_s and of filter_cnt channel */
+  fb->filters = new_fvec(win_s, n_filters);
 
   return fb;
 }
 
-/*
-FB initialization based on Slaney's auditory toolbox
-TODO:
-  *solve memory leak problems while
-  *solve quantization issues when constructing signal:
-    *bug for win_s=512
-    *corrections for win_s=1024 -> why even filters with smaller amplitude
-
-*/
-
-aubio_filterbank_t * new_aubio_filterbank_mfcc(uint_t n_filters, uint_t win_s, uint_t samplerate, smpl_t freq_min, smpl_t freq_max){
-  
-  aubio_filterbank_t * fb = new_aubio_filterbank(n_filters, win_s);
-  
-  
-  //slaney params
-  smpl_t lowestFrequency = 133.3333;
-  smpl_t linearSpacing = 66.66666666;
-  smpl_t logSpacing = 1.0711703;
-
-  uint_t linearFilters = 13;
-  uint_t logFilters = 27;
-  uint_t allFilters = linearFilters + logFilters;
-  
-  //buffers for computing filter frequencies
-  fvec_t * freqs=new_fvec(allFilters+2 , 1);
-  
-  fvec_t * lower_freqs=new_fvec( allFilters, 1);
-  fvec_t * upper_freqs=new_fvec( allFilters, 1);
-  fvec_t * center_freqs=new_fvec( allFilters, 1);
-
-  fvec_t * triangle_heights=new_fvec( allFilters, 1);
-  //lookup table of each bin frequency in hz
-  fvec_t * fft_freqs=new_fvec(win_s, 1);
-
-  uint_t filter_cnt, bin_cnt;
-  
-  //first step: filling all the linear filter frequencies
-  for(filter_cnt=0; filter_cnt<linearFilters; filter_cnt++){
-    freqs->data[0][filter_cnt]=lowestFrequency+ filter_cnt*linearSpacing;
-  }
-  smpl_t lastlinearCF=freqs->data[0][filter_cnt-1];
-  
-  //second step: filling all the log filter frequencies
-  for(filter_cnt=0; filter_cnt<logFilters+2; filter_cnt++){
-    freqs->data[0][filter_cnt+linearFilters] = 
-      lastlinearCF*(pow(logSpacing,filter_cnt+1));
-  }
-
-  //Option 1. copying interesting values to lower_freqs, center_freqs and upper freqs arrays
-  //TODO: would be nicer to have a reference to freqs->data, anyway we do not care in this init step
-    
-  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
-    lower_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt];
-    center_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt+1];
-    upper_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt+2];
-  }
-
-  //computing triangle heights so that each triangle has unit area
-  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
-    triangle_heights->data[0][filter_cnt] = 2./(upper_freqs->data[0][filter_cnt] 
-      - lower_freqs->data[0][filter_cnt]);
-  }
-  
-  //AUBIO_DBG("filter tables frequencies\n");
-  //for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++)
-  //  AUBIO_DBG("filter n. %d %f %f %f %f\n",
-  //    filter_cnt, lower_freqs->data[0][filter_cnt], 
-  //    center_freqs->data[0][filter_cnt], upper_freqs->data[0][filter_cnt], 
-  //    triangle_heights->data[0][filter_cnt]);
-
-  //filling the fft_freqs lookup table, which assigns the frequency in hz to each bin
-  for(bin_cnt=0; bin_cnt<win_s; bin_cnt++){
-    fft_freqs->data[0][bin_cnt]= aubio_bintofreq(bin_cnt, samplerate, win_s);
-  }
-
-  //building each filter table
-  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
-
-    //TODO:check special case : lower freq =0
-    //calculating rise increment in mag/Hz
-    smpl_t riseInc= triangle_heights->data[0][filter_cnt]/(center_freqs->data[0][filter_cnt]-lower_freqs->data[0][filter_cnt]);
-    
-    //zeroing begining of filter
-    for(bin_cnt=0; bin_cnt<win_s-1; bin_cnt++){
-      fb->filters[filter_cnt]->data[0][bin_cnt]=0.f;
-      if( fft_freqs->data[0][bin_cnt]  <= lower_freqs->data[0][filter_cnt] &&
-          fft_freqs->data[0][bin_cnt+1] > lower_freqs->data[0][filter_cnt]) {
-        break;
-      }
-    }
-    bin_cnt++;
-    
-    //positive slope
-    for(; bin_cnt<win_s-1; bin_cnt++){
-      fb->filters[filter_cnt]->data[0][bin_cnt]=(fft_freqs->data[0][bin_cnt]-lower_freqs->data[0][filter_cnt])*riseInc;
-      //if(fft_freqs->data[0][bin_cnt]<= center_freqs->data[0][filter_cnt] && fft_freqs->data[0][bin_cnt+1]> center_freqs->data[0][filter_cnt])
-      if(fft_freqs->data[0][bin_cnt+1]> center_freqs->data[0][filter_cnt])
-        break;
-    }
-    //bin_cnt++;
-    
-    //negative slope
-    for(; bin_cnt<win_s-1; bin_cnt++){
-      
-      //checking whether last value is less than 0...
-      smpl_t val=triangle_heights->data[0][filter_cnt]-(fft_freqs->data[0][bin_cnt]-center_freqs->data[0][filter_cnt])*riseInc;
-      if(val>=0)
-        fb->filters[filter_cnt]->data[0][bin_cnt]=val;
-      else fb->filters[filter_cnt]->data[0][bin_cnt]=0.f;
-      
-      //if(fft_freqs->data[0][bin_cnt]<= upper_freqs->data[0][bin_cnt] && fft_freqs->data[0][bin_cnt+1]> upper_freqs->data[0][filter_cnt])
-      //TODO: CHECK whether bugfix correct
-      if(fft_freqs->data[0][bin_cnt+1]> upper_freqs->data[0][filter_cnt])
-        break;
-    }
-    //bin_cnt++;
-    
-    //zeroing tail
-    for(; bin_cnt<win_s; bin_cnt++)
-      fb->filters[filter_cnt]->data[0][bin_cnt]=0.f;
-
-  }
-  
-  
-  del_fvec(freqs);
-  del_fvec(lower_freqs);
-  del_fvec(upper_freqs);
-  del_fvec(center_freqs);
-
-  del_fvec(triangle_heights);
-  del_fvec(fft_freqs);
-
-  return fb;
-
-}
-
 void del_aubio_filterbank(aubio_filterbank_t * fb){
-  uint_t filter_cnt;
-  /** deleting filter tables first */
-  for (filter_cnt=0; filter_cnt<fb->n_filters; filter_cnt++)
-    del_fvec(fb->filters[filter_cnt]);
-  AUBIO_FREE(fb->filters);
+  del_fvec(fb->filters);
   AUBIO_FREE(fb);
 }
 
 void aubio_filterbank_do(aubio_filterbank_t * f, cvec_t * in, fvec_t *out) {
-  uint_t n, filter_cnt;
-  for(filter_cnt = 0; (filter_cnt < f->n_filters)
-    && (filter_cnt < out->length); filter_cnt++){
-      out->data[0][filter_cnt] = 0.f;
-      for(n = 0; n < in->length; n++){
-          out->data[0][filter_cnt] += in->norm[0][n] 
-            * f->filters[filter_cnt]->data[0][n];
+  uint_t i, j, fn;
+
+  /* apply filter to all input channel, provided out has enough channels */
+  uint_t max_channels = MIN(in->channels, out->channels);
+  uint_t max_filters  = MIN(f->n_filters, out->length);
+
+  /* reset all values in output vector */
+  fvec_zeros(out);
+
+  /* apply filters on all channels */
+  for (i = 0; i < max_channels; i++) {
+
+    /* for each filter */
+    for(fn = 0; fn < max_filters; fn++) {
+
+      /* for each sample */
+      for(j = 0; j < in->length; j++) {
+          out->data[i][fn] += in->norm[i][j] * f->filters->data[fn][j];
       }
-      out->data[0][filter_cnt] =
-        LOG(out->data[0][filter_cnt] < VERY_SMALL_NUMBER ? 
-            VERY_SMALL_NUMBER : out->data[0][filter_cnt]);
+
+      /* threshold to VERY_SMALL_NUMBER to avoid log oveflow */
+      out->data[i][fn] = MAX(VERY_SMALL_NUMBER, out->data[i][fn]);
+
+      /* compute logarithm */
+      out->data[i][fn] = LOG(out->data[i][fn]);
+    }
   }
 
@@ -214,6 +84,5 @@
 }
 
-fvec_t * aubio_filterbank_getchannel(aubio_filterbank_t * f, uint_t channel) {
-  if ( (channel < f->n_filters) ) { return f->filters[channel]; }
-  else { return NULL; }
+fvec_t * aubio_filterbank_get_coeffs(aubio_filterbank_t * f) {
+  return f->filters;
 }
Index: src/spectral/filterbank.h
===================================================================
--- src/spectral/filterbank.h	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ src/spectral/filterbank.h	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -1,19 +1,21 @@
 /*
-   Copyright (C) 2007 Amaury Hazan <ahazan@iua.upf.edu>
-                  and Paul Brossier <piem@piem.org>
+  Copyright (C) 2007-2009 Paul Brossier <piem@aubio.org>
+                      and Amaury Hazan <ahazan@iua.upf.edu>
 
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
+  This file is part of Aubio.
 
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
+  Aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
 
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+  Aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Aubio.  If not, see <http://www.gnu.org/licenses/>.
+
 */
 
@@ -22,5 +24,5 @@
   Filterbank object
 
-  General-purpose spectral filterbank object. Comes with mel-filter initialization function.
+  General-purpose spectral filterbank object.
 
 */
@@ -45,16 +47,4 @@
 aubio_filterbank_t * new_aubio_filterbank(uint_t n_filters, uint_t win_s);
 
-/** filterbank initialization for mel filters
-
-  
-  \param n_filters number of filters
-  \param win_s window size
-  \param samplerate
-  \param freq_min lowest filter frequency
-  \param freq_max highest filter frequency
-
-*/
-aubio_filterbank_t * new_aubio_filterbank_mfcc(uint_t n_filters, uint_t win_s, uint_t samplerate, smpl_t freq_min, smpl_t freq_max);
-
 /** destroy filterbank object
 
@@ -66,11 +56,17 @@
 /** compute filterbank
 
+  \param fb filterbank containing     nfilt x win_s filter coefficients
+  \param in input spectrum containing chans x win_s spectrum
+  \param out output vector containing chans x nfilt output values
+
 */
 void aubio_filterbank_do(aubio_filterbank_t * fb, cvec_t * in, fvec_t *out);
 
-/** return the vector containing the filter coefficients of one channel
+/** return a pointer to the fvec object containing all filter coefficients 
+
+  \param f filterbank object to get coefficients from
 
  */
-fvec_t * aubio_filterbank_getchannel(aubio_filterbank_t * f, uint_t channel);
+fvec_t * aubio_filterbank_get_coeffs(aubio_filterbank_t * f);
 
 #ifdef __cplusplus
Index: src/spectral/filterbank_mel.c
===================================================================
--- src/spectral/filterbank_mel.c	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
+++ src/spectral/filterbank_mel.c	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -0,0 +1,152 @@
+/*
+  Copyright (C) 2007-2009 Paul Brossier <piem@aubio.org>
+                      and Amaury Hazan <ahazan@iua.upf.edu>
+
+  This file is part of Aubio.
+
+  Aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  Aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Aubio.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+#include "aubio_priv.h"
+#include "fvec.h"
+#include "cvec.h"
+#include "spectral/filterbank.h"
+#include "mathutils.h"
+
+void aubio_filterbank_set_mel_coeffs(aubio_filterbank_t *fb, uint_t samplerate, smpl_t freq_min, smpl_t freq_max){
+
+  fvec_t *filters = aubio_filterbank_get_coeffs(fb);
+  uint_t n_filters = filters->channels, win_s = filters->length;
+  
+  //slaney params
+  smpl_t lowestFrequency = 133.3333;
+  smpl_t linearSpacing = 66.66666666;
+  smpl_t logSpacing = 1.0711703;
+
+  uint_t linearFilters = 13;
+  uint_t logFilters = 27;
+  uint_t allFilters = linearFilters + logFilters;
+  
+  //buffers for computing filter frequencies
+  fvec_t * freqs=new_fvec(allFilters+2 , 1);
+  
+  fvec_t * lower_freqs=new_fvec( allFilters, 1);
+  fvec_t * upper_freqs=new_fvec( allFilters, 1);
+  fvec_t * center_freqs=new_fvec( allFilters, 1);
+
+  fvec_t * triangle_heights=new_fvec( allFilters, 1);
+  //lookup table of each bin frequency in hz
+  fvec_t * fft_freqs=new_fvec(win_s, 1);
+
+  uint_t filter_cnt, bin_cnt;
+  
+  //first step: filling all the linear filter frequencies
+  for(filter_cnt=0; filter_cnt<linearFilters; filter_cnt++){
+    freqs->data[0][filter_cnt]=lowestFrequency+ filter_cnt*linearSpacing;
+  }
+  smpl_t lastlinearCF=freqs->data[0][filter_cnt-1];
+  
+  //second step: filling all the log filter frequencies
+  for(filter_cnt=0; filter_cnt<logFilters+2; filter_cnt++){
+    freqs->data[0][filter_cnt+linearFilters] = 
+      lastlinearCF*(pow(logSpacing,filter_cnt+1));
+  }
+
+  //Option 1. copying interesting values to lower_freqs, center_freqs and upper freqs arrays
+  //TODO: would be nicer to have a reference to freqs->data, anyway we do not care in this init step
+    
+  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
+    lower_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt];
+    center_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt+1];
+    upper_freqs->data[0][filter_cnt]=freqs->data[0][filter_cnt+2];
+  }
+
+  //computing triangle heights so that each triangle has unit area
+  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
+    triangle_heights->data[0][filter_cnt] = 2./(upper_freqs->data[0][filter_cnt] 
+      - lower_freqs->data[0][filter_cnt]);
+  }
+  
+  //AUBIO_DBG("filter tables frequencies\n");
+  //for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++)
+  //  AUBIO_DBG("filter n. %d %f %f %f %f\n",
+  //    filter_cnt, lower_freqs->data[0][filter_cnt], 
+  //    center_freqs->data[0][filter_cnt], upper_freqs->data[0][filter_cnt], 
+  //    triangle_heights->data[0][filter_cnt]);
+
+  //filling the fft_freqs lookup table, which assigns the frequency in hz to each bin
+  for(bin_cnt=0; bin_cnt<win_s; bin_cnt++){
+    fft_freqs->data[0][bin_cnt]= aubio_bintofreq(bin_cnt, samplerate, win_s);
+  }
+
+  //building each filter table
+  for(filter_cnt=0; filter_cnt<allFilters; filter_cnt++){
+
+    //TODO:check special case : lower freq =0
+    //calculating rise increment in mag/Hz
+    smpl_t riseInc= triangle_heights->data[0][filter_cnt]/(center_freqs->data[0][filter_cnt]-lower_freqs->data[0][filter_cnt]);
+    
+    //zeroing begining of filter
+    for(bin_cnt=0; bin_cnt<win_s-1; bin_cnt++){
+      filters->data[filter_cnt][bin_cnt]=0.0;
+      if( fft_freqs->data[0][bin_cnt]  <= lower_freqs->data[0][filter_cnt] &&
+          fft_freqs->data[0][bin_cnt+1] > lower_freqs->data[0][filter_cnt]) {
+        break;
+      }
+    }
+    bin_cnt++;
+    
+    //positive slope
+    for(; bin_cnt<win_s-1; bin_cnt++){
+      filters->data[filter_cnt][bin_cnt]=(fft_freqs->data[0][bin_cnt]-lower_freqs->data[0][filter_cnt])*riseInc;
+      //if(fft_freqs->data[0][bin_cnt]<= center_freqs->data[0][filter_cnt] && fft_freqs->data[0][bin_cnt+1]> center_freqs->data[0][filter_cnt])
+      if(fft_freqs->data[0][bin_cnt+1]> center_freqs->data[0][filter_cnt])
+        break;
+    }
+    //bin_cnt++;
+    
+    //negative slope
+    for(; bin_cnt<win_s-1; bin_cnt++){
+      
+      //checking whether last value is less than 0...
+      smpl_t val=triangle_heights->data[0][filter_cnt]-(fft_freqs->data[0][bin_cnt]-center_freqs->data[0][filter_cnt])*riseInc;
+      if(val>=0)
+        filters->data[filter_cnt][bin_cnt]=val;
+      else filters->data[filter_cnt][bin_cnt]=0.0;
+      
+      //if(fft_freqs->data[0][bin_cnt]<= upper_freqs->data[0][bin_cnt] && fft_freqs->data[0][bin_cnt+1]> upper_freqs->data[0][filter_cnt])
+      //TODO: CHECK whether bugfix correct
+      if(fft_freqs->data[0][bin_cnt+1]> upper_freqs->data[0][filter_cnt])
+        break;
+    }
+    //bin_cnt++;
+    
+    //zeroing tail
+    for(; bin_cnt<win_s; bin_cnt++)
+      filters->data[filter_cnt][bin_cnt]=0.f;
+
+  }
+  
+  /* destroy temporarly allocated vectors */  
+  del_fvec(freqs);
+  del_fvec(lower_freqs);
+  del_fvec(upper_freqs);
+  del_fvec(center_freqs);
+
+  del_fvec(triangle_heights);
+  del_fvec(fft_freqs);
+
+}
+
Index: src/spectral/filterbank_mel.h
===================================================================
--- src/spectral/filterbank_mel.h	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
+++ src/spectral/filterbank_mel.h	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -0,0 +1,58 @@
+/*
+  Copyright (C) 2007-2009 Paul Brossier <piem@aubio.org>
+                      and Amaury Hazan <ahazan@iua.upf.edu>
+
+  This file is part of Aubio.
+
+  Aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  Aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Aubio.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+/** \file
+
+  Mel frequency filter bankd coefficients 
+
+  Set filter bank coefficients to Mel frequency bands.
+
+  The filter coefficients are built according to Malcolm Slaney's Auditory
+  Toolbox available at http://cobweb.ecn.purdue.edu/~malcolm/interval/1998-010/
+  (see the file mfcc.m). 
+
+*/
+
+#ifndef FILTERBANK_MEL_H
+#define FILTERBANK_MEL_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include "filterbank.h"
+
+/** filterbank initialization for mel filters
+
+  \param n_filters number of filters
+  \param win_s window size
+  \param samplerate
+  \param freq_min lowest filter frequency
+  \param freq_max highest filter frequency
+
+*/
+void aubio_filterbank_set_mel_coeffs(aubio_filterbank_t *fb, uint_t samplerate, smpl_t freq_min, smpl_t freq_max);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // FILTERBANK_MEL_H
Index: src/spectral/mfcc.c
===================================================================
--- src/spectral/mfcc.c	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ src/spectral/mfcc.c	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -25,5 +25,5 @@
 #include "cvec.h"
 #include "spectral/fft.h"
-#include "spectral/filterbank.h"
+#include "spectral/filterbank_mel.h"
 #include "spectral/mfcc.h"
 
@@ -62,5 +62,6 @@
   
   /** filterbank allocation */
-  mfcc->fb = new_aubio_filterbank_mfcc(n_filters, mfcc->win_s, samplerate, lowfreq, highfreq);
+  mfcc->fb = new_aubio_filterbank(n_filters, mfcc->win_s);
+  aubio_filterbank_set_mel_coeffs(mfcc->fb, samplerate, lowfreq, highfreq);
 
   /** allocating space for fft object (used for dct) */
Index: swig/aubio.i
===================================================================
--- swig/aubio.i	(revision 7bf3dcb9e077fe0902daf398de7411310c6f5431)
+++ swig/aubio.i	(revision 06cae6cc6c312a179e19503edfd430ef1c64cf6f)
@@ -163,8 +163,8 @@
 /* filterbank */
 aubio_filterbank_t * new_aubio_filterbank(uint_t win_s, uint_t channels);
-aubio_filterbank_t * new_aubio_filterbank_mfcc(uint_t n_filters, uint_t win_s, uint_t samplerate, smpl_t freq_min, smpl_t freq_max);
+void aubio_filterbank_set_mel_coeffs(aubio_filterbank_t *fb, uint_t samplerate, smpl_t freq_min, smpl_t freq_max);
 void del_aubio_filterbank(aubio_filterbank_t * fb);
 void aubio_filterbank_do(aubio_filterbank_t * fb, cvec_t * in, fvec_t *out);
-fvec_t * aubio_filterbank_getchannel(aubio_filterbank_t * fb, uint_t channel);
+fvec_t * aubio_filterbank_get_coeffs(aubio_filterbank_t * fb);
 
 /* mfcc */
